# Contributing

## Introduction

Following these guidelines helps to communicate that you respect the time of the developers managing and developing this open source project. In return, they should reciprocate that respect in addressing your issue, assessing changes, and helping you finalize your pull requests.

Your input is appreciated! We want to make contributing to this project as easy and transparent as possible, whether it's:
 - Reporting a bug
 - Discussing the current state of the code
 - Submitting a fix
 - Writing code that can be incorporated into the project itself
 - Proposing new features
 - Improving the documentation
 - Writing tutorials or blog posts
 - Becoming a maintainer

When contributing to this repository, please first discuss the change you wish to make via issue before making a change. 

As for everything else in the project, the contributions to this repo are governed by the [Code of Conduct](/CODE_OF_CONDUCT.md).

## Using the issue tracker

The issue tracker is the preferred channel for bug reports, features requests and submitting pull requests.

## Your first contribution

Working on your first Pull Request? You can learn how from this free series, [How to Contribute to an Open Source Project on GitHub](https://egghead.io/series/how-to-contribute-to-an-open-source-project-on-github).

## Pull request process

 1. Fork the repo, clone it to your own machine and create your branch from `master`
 2. Commit changes to your branch
 3. If you've added code that should be tested, add tests
 4. If you've changed APIs, or if needed, update the documentation, README, etc.
 5. Ensure the test suite passes.
 6. Make sure formatting is according to the repo`s style guidelines. Use a linter if needed.
 7. Push your work back to your fork
 8. Create that pull request
 9. Pass the review, reiterate if requests are made by the maintainers

NOTE: Be sure to merge the latest from "upstream" before making a pull request!

## Reviews

Don't forget to review your own code first. Does it make sense? Did you include something unrelated to the overall purpose of the changes? Did you forget to remove any debugging code?

The code review process is based on the following guidelines:
* [Gitlab's Code Review Guidelines](https://gitlab.com/help/development/code_review.md)
* [thoughtbot's Code Review Guidelines](https://github.com/thoughtbot/guides/tree/master/code-review)

Especially pay attention to the ["Having your code reviewed"](https://gitlab.com/help/development/code_review.md#having-your-code-reviewed) section.

## Copyright and Licensing

All of your contributions will be made under GPLv3.0.

## FAQ